#ifndef GFXARCBALL_INCLUDED // -*- C++ -*-
#define GFXARCBALL_INCLUDED
#if !defined(__GNUC__)
#  pragma once
#endif

/************************************************************************

  Arcball rotation control.
  
  $Id: arcball.h,v 1.2 2000/11/03 19:02:07 garland Exp $

 ************************************************************************/

#include "quat.h"

class Arcball
{
private:
    Vec2 ball_ctr;
    double ball_radius;

    Vec3 ctr;		// Describes a bounding sphere of object
    double radius;

    Vec3 cam;
    Quat q_now, q_down, q_drag;
    Vec3 v_from, v_to;

    bool is_dragging;

protected:
    Vec3 proj_to_sphere(const Vec2&);
    void update();


public:
    Arcball();

    void bounding_sphere(float cx, float cy, float cz, float r);
    void bounding_sphere(const Vec3f& v, float r);
    void bounding_sphere(const Vec3& v, double r);

    virtual void update_animation();
    virtual bool mouse_down(int *where, int which);
    virtual bool mouse_up(int *where, int which);
    virtual bool mouse_drag(int *where, int *last, int which);

    virtual void apply_transform();
    virtual void unapply_transform();
};



// GFXARCBALL_INCLUDED
#endif
