#ifndef GFXGEOM3D_INCLUDED
#define GFXGEOM3D_INCLUDED
#if !defined(__GNUC__)
#  pragma once
#endif

/************************************************************************

  Handy 3D geometrical primitives

  $Id: geom3d.h,v 1.1 2000/05/24 19:32:22 garland Exp $

 ************************************************************************/

#include "vec3.h"
#include "vec4.h"

extern double triangle_area(const Vec3&, const Vec3&, const Vec3&);

extern Vec3 triangle_raw_normal(const Vec3&, const Vec3&, const Vec3&);
extern Vec3 triangle_normal(const Vec3&, const Vec3&, const Vec3&);

extern Vec4 triangle_raw_plane(const Vec3&, const Vec3&, const Vec3&);
extern Vec4 triangle_plane(const Vec3&, const Vec3&, const Vec3&);

extern double triangle_compactness(const Vec3&, const Vec3&, const Vec3&);

// GFXGEOM3D_INCLUDED
#endif
