/************************************************************************

  2x2 Matrix class

  $Id: mat2.cxx,v 1.2 2000/05/04 20:37:55 garland Exp $

 ************************************************************************/

#include <gfx/gfx.h>
#include <gfx/mat2.h>

Mat2 Mat2::I() { return Mat2(1,0,  0,1); }

Mat2 &Mat2::diag(double d)
{
    row[0][0] = d;   row[0][1] = 0;
    row[1][0] = 0;   row[1][1] = d;

    return *this;
}

Mat2 operator*(const Mat2 &n, const Mat2& m)
{
    Mat2 A;
    int i,j;

    for(i=0;i<2;i++)
	for(j=0;j<2;j++)
	    A(i,j) = n[i]*m.col(j);

    return A;
}

double invert(Mat2 &inv, const Mat2 &m)
{
    double d = det(m);

    if( d==0.0 )
	return 0.0;

    inv(0, 0) =  m(1,1)/d;
    inv(0, 1) = -m(1,0)/d;
    inv(1, 0) = -m(0,1)/d;
    inv(1, 1) =  m(0,0)/d;

    return d;
}
